'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.transform = undefined;

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var transform = exports.transform = function transform(envs) {
  var defaultEnv = arguments.length <= 1 || arguments[1] === undefined ? 'development' : arguments[1];
  var importRelPath = arguments[2];
  var filename = arguments[3];

  var envExt = envs[process.env.NODE_ENV || defaultEnv];

  if (typeof envExt === 'undefined') {
    return;
  }

  var dirname = _path2.default.dirname(filename);
  var importedFilename = _path2.default.normalize(dirname + '/' + importRelPath);
  var importedExtname = _path2.default.extname(importedFilename);

  var envDirname = _path2.default.dirname(importedFilename);
  var envExtname = importedExtname || '.js';
  var envBasename = _path2.default.basename(importedFilename, envExtname);

  var envFilename = envDirname + '/' + envBasename + '.' + envExt + envExtname;

  _fs2.default.accessSync(envFilename);

  var newImportDirname = _path2.default.dirname(importRelPath);
  var newImportBasename = _path2.default.basename(importRelPath, importedExtname);
  return newImportDirname + '/' + newImportBasename + '.' + envExt + importedExtname;
};

exports.default = function (_ref) {
  var types = _ref.types;

  return {
    visitor: {
      ImportDeclaration: function ImportDeclaration(nodePath, state) {
        var envs = state.opts.envMap || {
          production: 'prod',
          development: 'dev'
        };

        var node = nodePath.node;


        try {
          node.source = types.stringLiteral(transform(envs, state.opts.defaultEnv, node.source.value, state.file.opts.filename));
        } catch (err) {
          // will use default import statement
        }
      }
    }
  };
};